# Class NoOpCallStack

java.lang.Object
org.apache.tomcat.dbcp.pool2.impl.NoOpCallStack

All Implemented Interfaces:
  `CallStack`

public class NoOpCallStack extends Object implements CallStack
CallStack strategy using no-op implementations of all functionality. Can be used by default when abandoned object logging is disabled.

Since:
  2.5

## Field Summary

Fields
Modifier and Type
Field
Description
`static final CallStack`
`INSTANCE`
Singleton instance.

## Method Summary

Modifier and Type
Method
Description
`void`
`clear()`
Clears the current stack trace snapshot.
`void`
`fillInStackTrace()`
Takes a snapshot of the current call stack.
`boolean`
`printStackTrace(PrintWriter writer)`
Prints the current stack trace if available to a PrintWriter.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### INSTANCE

public static final CallStack INSTANCE
Singleton instance.

## Method Details

### clear

public void clear()
Description copied from interface: `CallStack`
Clears the current stack trace snapshot. Subsequent calls to `CallStack.printStackTrace(PrintWriter)` will be no-ops until another call to `CallStack.fillInStackTrace()`.

Specified by:
  `clear` in interface `CallStack`

### fillInStackTrace

public void fillInStackTrace()
Description copied from interface: `CallStack`
Takes a snapshot of the current call stack. Subsequent calls to `CallStack.printStackTrace(PrintWriter)` will print out that stack trace until it is cleared.

Specified by:
  `fillInStackTrace` in interface `CallStack`

### printStackTrace

public boolean printStackTrace(PrintWriter writer)
Description copied from interface: `CallStack`
Prints the current stack trace if available to a PrintWriter. The format is undefined and is primarily useful for debugging issues with `PooledObject` usage in user code.

Specified by:
  `printStackTrace` in interface `CallStack`
Parameters:
  `writer` - a PrintWriter to write the current stack trace to if available
Returns:
  true if a stack trace was available to print or false if nothing was printed